// MilAplication.cpp: implementation of the CMilAplication class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#include "MilAplication.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CMilAplication::CMilAplication(){		

   Time            = 0.0;
   TimeWait        = 0.0;
   TotalReplay     = 0.0;
   ImageScale      = 1;
   n               = 0;
   ExtendedAttrib  = 0;
   NbFrames        = 0;
   Selection       = 1;
   LicenseModules  = 0;

	m_MaxGrabNum = NB_GRAB;

   /* Allocate defaults. */
   MappAllocDefault(M_SETUP, &MilApplication, &MilSystem,&MilDisplay, &MilDigitizer, M_NULL);
	
   /* Allocate display buffer. */   

   /* Disable errors */            
   MappControl(M_ERROR, M_PRINT_DISABLE);

   MbufAllocColor(MilSystem,MdigInquire(MilDigitizer, M_SIZE_BAND, M_NULL),
                  (long)(MdigInquire(MilDigitizer, M_SIZE_X, M_NULL)*ImageScale),
                  (long)(MdigInquire(MilDigitizer, M_SIZE_Y, M_NULL)*ImageScale),
                   8L+M_UNSIGNED,M_IMAGE+M_GRAB+M_DISP+ExtendedAttrib,&MilImageAux);
   
   /* Allocate grab buffers to hold the sequence. */                  
   for (n=0; n<NB_GRAB; n++)
      {
      MbufAllocColor(MilSystem,  
                     MdigInquire(MilDigitizer, M_SIZE_BAND, M_NULL),
                     (long)(MdigInquire(MilDigitizer, M_SIZE_X, M_NULL)*ImageScale),
                     (long)(MdigInquire(MilDigitizer, M_SIZE_Y, M_NULL)*ImageScale),
                     8L+M_UNSIGNED, 
                     M_IMAGE+M_GRAB+M_DISP+ExtendedAttrib, &MilImage[n]);
      if (MilImage[n])                     
         {
         NbFrames++;
         if ( ExtendedAttrib )
            MbufControl( MilImage[n], M_Q_FACTOR, Q_FACTOR );
         }
      else
         {
         break;
         }
      }	

	AskForLimits();

}


void CMilAplication::AskForLimits(){

	MdigInquire(MilDigitizer,M_HUE+ M_MIN_VALUE,&Hue_min);
	MdigInquire(MilDigitizer,M_HUE+ M_MAX_VALUE,&Hue_max);
    MdigInquire(MilDigitizer,M_SATURATION+ M_MIN_VALUE,&Sat_min);
	MdigInquire(MilDigitizer,M_SATURATION+ M_MAX_VALUE,&Sat_max);
	MdigInquire(MilDigitizer,M_BRIGHTNESS+ M_MIN_VALUE,&Brig_min);
	MdigInquire(MilDigitizer,M_BRIGHTNESS+ M_MAX_VALUE,&Brig_max);
	MdigInquire(MilDigitizer,M_WHITE_BALANCE_U+ M_MIN_VALUE,&WBU_min);
	MdigInquire(MilDigitizer,+M_WHITE_BALANCE_U+ M_MAX_VALUE,&WBU_max);
	MdigInquire(MilDigitizer,M_WHITE_BALANCE_V+ M_MIN_VALUE,&WBV_min);
	MdigInquire(MilDigitizer,+M_WHITE_BALANCE_V+ M_MAX_VALUE,&WBV_max);
	MdigInquire(MilDigitizer,+M_ZOOM + M_MAX_VALUE,&Zoom_max);
	MdigInquire(MilDigitizer,+M_ZOOM + M_MIN_VALUE,&Zoom_min);
	MdigInquire(MilDigitizer,+M_FOCUS + M_MAX_VALUE,&Focus_max);
	MdigInquire(MilDigitizer,+M_FOCUS + M_MIN_VALUE,&Focus_min);
	MdigInquire(MilDigitizer,+M_SHARPNESS + M_MAX_VALUE,&Sharp_max);
	MdigInquire(MilDigitizer,+M_SHARPNESS + M_MIN_VALUE,&Sharp_min);
}


void CMilAplication::SetDefaultsValues(){

	MdigControl(MilDigitizer,M_HUE,198);
	MdigControl(MilDigitizer,M_SATURATION,79);
	MdigControl(MilDigitizer,M_BRIGHTNESS,40);
	MdigControl(MilDigitizer,M_WHITE_BALANCE_U,159);
	MdigControl(MilDigitizer,M_WHITE_BALANCE_V,255);
	MdigControl(MilDigitizer,M_ZOOM,Zoom_min);
	MdigControl(MilDigitizer,M_FOCUS,Focus_max);
	MdigControl(MilDigitizer,M_SHARPNESS,Sharp_max);
}




//Funcions WBU
long CMilAplication::GetMinWBU(){
	return WBU_min;
}
long CMilAplication::GetMaxWBU(){
	return WBU_max;
}
void CMilAplication::ControlWhiteBalanceU(long value){
	MdigControl(MilDigitizer,M_WHITE_BALANCE_U,value);
}
//Funcions WBV
long CMilAplication::GetMinWBV(){
	return WBV_min;
}
long CMilAplication::GetMaxWBV(){
	return WBV_max;
}
void CMilAplication::ControlWhiteBalanceV(long value){
	MdigControl(MilDigitizer,M_WHITE_BALANCE_V,value);
}
//Funcions Hue
long CMilAplication::GetMinHue(){
	return WBV_min;
}
long CMilAplication::GetMaxHue(){
	return WBV_max;
}
void CMilAplication::ControlHue(long value){
	MdigControl(MilDigitizer,M_HUE,value);
}


//Funcions Sat
long CMilAplication::GetMinSat(){
	return Sat_min;
}
long CMilAplication::GetMaxSat(){
	return Sat_max;
}
void CMilAplication::ControlSat(long value){
	MdigControl(MilDigitizer,M_SATURATION,value);
}


//Funcions Brig
long CMilAplication::GetMinBrig(){
	return Brig_min;
}
long CMilAplication::GetMaxBrig(){
	return Brig_max;
}
void CMilAplication::ControlBrig(long value){
	MdigControl(MilDigitizer,M_BRIGHTNESS,value);
}


//Funcions ZOOM
long CMilAplication::GetMinZoom(){
	return Zoom_min;
}
long CMilAplication::GetMaxZoom(){
	return Zoom_max;
}
void CMilAplication::ControlZoom(long value){
	MdigControl(MilDigitizer,M_ZOOM,value);
}


//Funcions FOCUS
long CMilAplication::GetMinFocus(){
	return Focus_min;
}
long CMilAplication::GetMaxFocus(){
	return Focus_max;
}
void CMilAplication::ControlFocus(long value){
	Focus = value;
	MdigControl(MilDigitizer,M_FOCUS,value);
}


long CMilAplication::GetMinSharp(){
	return Sharp_min;
}
long CMilAplication::GetMaxSharp(){
	return Sharp_max;
}
void CMilAplication::ControlSharp(long value){
	Sharp = value;
	MdigControl(MilDigitizer,M_SHARPNESS,value);
}






void CMilAplication::GetFrame(){


	MdigGrab(MilDigitizer,MilImageAux);

}

void CMilAplication::ShowFrame(HWND finestra){
 // MdispSelect(MilDisplay,MilImage[0]);
  MdispSelectWindow(MilDisplay,MilImageAux,finestra);	
}

int CMilAplication::GetMaxNumFrames(){
	return m_MaxGrabNum;
}

CMilAplication::~CMilAplication()
{
   /* Free all allocated buffers. */
   for (n=0; n<NbFrames; n++)
      {
      MbufFree(MilImage[n]);
      }

   MbufFree(MilImageAux);
   
   /* Release defaults. */
   MappFreeDefault(MilApplication, MilSystem, MilDisplay,
                   MilDigitizer, M_NULL);

}

void CMilAplication::AddImageToArray(int i){
	MbufCopy(MilImageAux,MilImage[i]);
}

void CMilAplication::CreateAvi(char *filename, int numframes){
	
	MbufExportSequence(filename,
						M_AVI_DIB,
						MilImage,
						numframes,8,M_DEFAULT);
			
}




void CMilAplication::LoadFramesFromFile(char *Name,int *nframes,int *framerate){

	*nframes = MbufDiskInquire(Name,M_NUMBER_OF_IMAGES,M_NULL);
	*framerate = MbufDiskInquire(Name,M_FRAME_RATE,M_NULL);
	MbufImportSequence(Name,
		               M_DEFAULT,
					   M_RESTORE,
					   MilSystem,
					   MilImage,
					   0,
					   *nframes,
					   M_DEFAULT);
}





void CMilAplication::ShowVideo(HWND finestra,int nframes,int framerate){
	
	double TimeWait = 1/double(framerate);
	for(int i =0;i<nframes;i++){
		MappTimer(M_TIMER_RESET,M_NULL);
		MbufCopy(MilImage[i],MilImageAux);
		ShowFrame(finestra);
		MappControlThread(M_DEFAULT,M_THREAD_WAIT,M_DEFAULT,M_NULL);
		MappTimer(M_TIMER_WAIT,&TimeWait);
	}
}













