// MilAplication.cpp: implementation of the CMilAplication class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#include "MilAplication.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CMilAplication::CMilAplication(){		

   Time            = 0.0;
   TimeWait        = 0.0;
   TotalReplay     = 0.0;
   ImageScale      = 0.5;
   n               = 0;
   ExtendedAttrib  = 0;
   NbFrames        = 0;
   Selection       = 1;
   LicenseModules  = 0;

   /* Allocate defaults. */
   MappAllocDefault(M_SETUP, &MilApplication, &MilSystem,&MilDisplay, &MilDigitizer, M_NULL);
	
   /* Allocate display buffer. */   
   MbufAllocColor(MilSystem,  
                  MdigInquire(MilDigitizer, M_SIZE_BAND, M_NULL),
                  (long)(MdigInquire(MilDigitizer, M_SIZE_X, M_NULL)*ImageScale),
                  (long)(MdigInquire(MilDigitizer, M_SIZE_Y, M_NULL)*ImageScale),
                  8L+M_UNSIGNED, 
                  M_IMAGE+M_GRAB+M_PROC+M_DISP, &MilImageDisp);

   /* Disable errors */            
   MappControl(M_ERROR, M_PRINT_DISABLE);                  
   
   /* Allocate grab buffers to hold the sequence. */                  
   for (n=0; n<NB_GRAB; n++)
      {
      MbufAllocColor(MilSystem,  
                     MdigInquire(MilDigitizer, M_SIZE_BAND, M_NULL),
                     (long)(MdigInquire(MilDigitizer, M_SIZE_X, M_NULL)*ImageScale),
                     (long)(MdigInquire(MilDigitizer, M_SIZE_Y, M_NULL)*ImageScale),
                     8L+M_UNSIGNED, 
                     M_IMAGE+M_GRAB+ExtendedAttrib, &MilImage[n]);
      if (MilImage[n])                     
         {
         NbFrames++;
         if ( ExtendedAttrib )
            MbufControl( MilImage[n], M_Q_FACTOR, Q_FACTOR );
         }
      else
         {
         break;
         }
      }	

}











	//LLegim les dimensions de la finestra
/*	Dlg->m_ImWin.GetWindowRect(&Rect);
	m_nSizeX = (Rect.right - Rect.left);
	m_nSizeY = (Rect.bottom - Rect.top);



CMilAplication::CMilAplication(CVisioPaletDlg *Dlg)
{	
	CRect Rect;
	//Alocatacions de l'aplicaci i sistema.
	MappAlloc(M_DEFAULT, &MilApplication);
	//Alocataci del sistema.
	MsysAlloc(M_SYSTEM_VGA, M_DEV0, M_NO_DDRAW, &MilSystem);	
	//Alocatacions dels displays.
	MdispAlloc(MilSystem, M_DEFAULT, M_DEF_DISPLAY_FORMAT, M_DEFAULT, &MilDisplay);	

	//LLegim les dimensions de la finestra
	Dlg->m_ImWin.GetWindowRect(&Rect);
	m_nSizeX = (Rect.right - Rect.left);
	m_nSizeY = (Rect.bottom - Rect.top);
	//Guardem espai per enmagatzemar una imatge que serveixi de display.
	MbufAlloc2d(MilSystem,m_nSizeX,m_nSizeY,8+M_UNSIGNED,M_IMAGE+M_DISP,&MilImatge_Disp);	
}
*/

CMilAplication::~CMilAplication()
{
   /* Free all allocated buffers. */
   for (n=0; n<NbFrames; n++)
      {
      MbufFree(MilImage[n]);
      }
   MbufFree(MilImageDisp);
   
   /* Release defaults. */
   MappFreeDefault(MilApplication, MilSystem, MilDisplay,
                   MilDigitizer, M_NULL);


}










































/*
void CMilAplication::GetImageFromFile(char *path,char *name){

    char* text1;
	
    double scalx;
	double scaly;
	
	text1="quadrat1.bmp";
	//strcpy(text1,path);
	//strcat(text1,name);
	//Carreguem el fitxer a MilImatge
	MbufRestore(text1,MilSystem,&MilImatgeSource);
	//Demanem les longituds de la imatge del fitxer.
	MbufInquire(MilImatgeSource,M_SIZE_X,&m_nSource_SizeX);
	MbufInquire(MilImatgeSource,M_SIZE_Y,&m_nSource_SizeY);
	//Calculem els escalats
	scalx=double(double(m_nSizeX)/double(m_nSource_SizeX));
	scaly=double(double(m_nSizeY)/double(m_nSource_SizeY));
	//Guardem espai en memoria per la imatge de la font.
	//redimensionem la imatge de la font i la guardem al fitxer.
	MimResize(MilImatgeSource,MilImatge_Disp,scalx,scaly,M_DEFAULT);
}*/

/*
void CMilAplication::VisualitzarImatge(HWND finestra,MIL_ID Imatge,MIL_ID ImDisp){

	MdispSelectWindow(ImDisp,Imatge,finestra);	
	
}

MIL_ID CMilAplication::GetImDisp(){
	return MilDisplay;
}
*/

